<?php
/* PreRequires */
    header("Expires: Tue, 01 Jan 2000 00:00:00 GMT");
    header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
    header("Cache-Control: no-store, no-cache, must-revalidate, max-age=0");
    header("Cache-Control: post-check=0, pre-check=0", false);
    header("Pragma: no-cache");
    require('./sources/localization.php');    // Localization
    require('./sources/config.php');   // Configuration
    require('./sources/utils.php');   // Configuration
/* END PreRequires */
/* Language for localization */
    $languages = explode(',',$_SERVER['HTTP_ACCEPT_LANGUAGE']);
    $ini = readIniFile();

    foreach($languages as $lang)
    {
        if(in_array(substr($lang,0,2), $SUPPORTED_LANGS))
        {
            // Set the page locale to the first supported language found
            $currLang = substr($lang,0,2);
            break;
        }
    }
    if ($_SERVER['HTTP_ACCEPT_LANGUAGE'] == "" || isLocalhost()) {
        if (isset($ini["application"]) && isset($ini["application"]["language"]) && $ini["application"]["language"] != "")
            $currLang = $ini["application"]["language"];
        else
            $currLang = "en";
    } else if ($currLang == "") {
        $currLang = "en";
    }
    switch($currLang) {
        case "cs":
            define("CHARSET","UTF-8");
            define("LANGCODE", "cs");
        break;
        default:
            define("CHARSET","UTF-8");
            define("LANGCODE", "en");
        break;
    }

/* Text localization define ID -> TEXT */
    defineTexts($currLang);

/* Response definition */
    if (PHP_VERSION_ID > 40000) {
        header("Content-Type: text/html;charset=".CHARSET);
        header("Content-Language: ".LANGCODE);
        header("Content-: ".LANGCODE);
    }
/* Check user */
    include './sources/user.php';
/* Set language to session */
    $_SESSION['lang'] = "cs";

    if (get_storage(get_client_ip()) && get_storage(get_client_ip()) > time())
    {
    ?>
<!DOCTYPE html>
<html>
    <head>
        <title><?php echo S_DOCUMENT_TITLE ?></title>
        <script>
            var lang = {
                'S_RESTARTING_DEVICE' : "<?php echo S_RESTARTING_DEVICE ?>",
                'S_WAIT' : "<?php echo S_WAIT ?>",
                'S_FILE_LOAD_FAILED' : "<?php echo S_FILE_LOAD_FAILED ?>",
                'S_PASSWORD' : "<?php echo S_E_PASSWORD ?>",
                'S_CANCEL' : "<?php echo S_CANCEL ?>",
                'S_ON' : "<?php echo S_ON ?>",
                'S_OFF' : "<?php echo S_OFF ?>",
                'S_DELETE_DONE' : "<?php echo S_DELETE_DONE ?>",
                'S_UPGRADE_CONFIRM' : "<?php echo S_UPGRADE_CONFIRM ?>"
            };
            var block_settings = {
                message: "<h1><?php echo S_WAIT ?></h1>",
                css: {
                    <?php if(isLocalhost()) { ?>
                        width: "500px",
                        left: "150px",
                    <?php } ?>
                    "font-family": "Arial,Helvetica,sans-serif"
                }
            };
            var upgrading = false;
        </script>
        <link href="styles/<?php echo MAIN_CSS_FILE ?>" rel="stylesheet" type="text/css"/>
        <link href="styles/jquery-ui.min.css" rel="stylesheet" type="text/css"/>
        <link href="styles/toggles.css" rel="stylesheet" type="text/css"/>
        <link href="styles/themes/toggles-modern.css" rel="stylesheet" type="text/css"/>
        <?php if (isLocalhost()) { ?>
        <link href="styles/localhost.css" rel="stylesheet" type="text/css"/>
        <?php } ?>
        <script src="js/jquery.js" type="text/javascript"></script>
        <script src="js/jquery-ui.min.js" type="text/javascript"></script>
        <script src="js/jquery.blockUI.js" type="text/javascript"></script>
        <script src="js/settings.js" type="text/javascript"></script>
        <script src="js/administration.js" type="text/javascript"></script>
        <script src="js/configuration.js" type="text/javascript"></script>
        <script src="js/main.js" type="text/javascript"></script>
        <script src="js/toggles.min.js" type="text/javascript"></script>
    </head>
    <div class="header ui-widget">
        <!--div class="logo"></div-->
        <div class="caption"><?php echo S_DOCUMENT_TITLE ?></div>
        <div class="languages"></div>
    </div>
    <div class="body ui-widget">
        <div class="menu">
            <ul>
                <li><a href="settings" class="selected"><?php echo S_SETTINGS ?></a></li>
                <li><a href="administration"><?php echo S_ADMINISTRATION ?></a></li>
                <li><a href="configuration"><?php echo S_CONFIGURATION ?></a></li>
            </ul>
            <div class="restart button"><?php echo S_RESTART ?></div>
        </div>
        <div class="content">
            <div id="settings">
                <h3><?php echo S_SETTINGS ?></h3>
                <div id="settings_error" class="ui-widget" style="display: table; width: 100%">
                    <div class="ui-state-error ui-corner-all" style="padding: 0 .7em;">
                        <p><span class="ui-icon ui-icon-alert" style="float: left; margin-right: .3em;"></span>
                        <span id="settings_error_message"></span></p>
                    </div>
                </div>
                <div class="table">
                    <div class="row">
                        <div class="attr_name"><?php echo S_LANGUAGE ?></div>
                        <div class="attr_value">
                            <select name="language">
                                <?php 
                                    if (isset($ini["application"]) && isset($ini["application"]["language"]) && $ini["application"]["language"] != "")
                                        $sel = $ini["application"]["language"];
                                    else
                                        $sel = "en";
                                    foreach ($SUPPORTED_LANGS as $lan)
                                    {
                                        echo '<option value="'.$lan.'"'.($sel==$lan ? " selected" : "").'>'.$SUPPORTED_LANGS_NAMES[$lan].'</option>';
                                    }
                                ?>
                            </select>
                        </div>
                    </div>
                    <div class="row">
                        <div class="attr_name">DHCP</div>
                        <div class="attr_value">
                            <div class="toggle toggle-modern dhcp"></div>
                            <input name="dhcp" type="checkbox" hidden="true">
                        </div>
                    </div>
                    <div class="row">
                        <div class="attr_name">MAC</div>
                        <div class="attr_value"><input name="mac" readonly/></div>
                    </div>
                    <div class="row">
                        <div class="attr_name"><?php echo S_IP_ADDRESS ?></div>
                        <div class="attr_value"><input name="ipAddress" class="required" value="" /></div>
                    </div>
                    <div class="row">
                        <div class="attr_name"><?php echo S_IP_MASK ?></div>
                        <div class="attr_value"><input name="netMask" class="required" value="" /></div>
                    </div>
                    <div class="row">
                        <div class="attr_name"><?php echo S_IP_GW ?></div>
                        <div class="attr_value"><input name="gateway" value="" /></div> 
                    </div>
                    <div class="row">
                        <div class="attr_name"><?php echo S_IP_DNS ?></div>
                        <div class="attr_value"><input name="dns" value="" /></div>
                    </div>
                    <div class="row">
                        <div class="attr_name"><?php echo S_SCREENSAVER_BACKLIGHT ?></div>
                        <div class="attr_value"><input name="screen_backlight" value="" /></div>
                    </div>
                    <div class="row">
                        <div class="attr_name"><?php echo S_SCREENSAVER_OFF ?></div>
                        <div class="attr_value"><input name="screen_off" value="" /></div>
                    </div>
                    <div class="row">
                        <div class="attr_name"><?php echo S_AUTO_LOGOUT ?></div>
                        <div class="attr_value"><input name="auto_logout" value="" /></div>
                    </div>
                    <div class="footer">
                        <div class="attr_name"></div>
                        <div class="attr_name"><div class="save button"><?php echo S_SAVE ?></div></div>
                    </div>
                </div>
            </div>
            <div id="administration">
                <h3><?php echo S_ADMINISTRATION ?></h3>
                <h4><?php echo S_VERSIONS ?></h4>
                <ul>
                    <li><b><?php echo S_WEB_NAME ?></b> - <?php getVersion() ?></li>
                    <li><b><?php echo S_APP_NAME ?></b> - <?php getAppVersion() ?></li>
                    <li><b>OS</b> - <?php getOSVersion() ?></li>
                </ul>
                <hr>
                <h4><?php echo S_CHANGE_PASSWORD ?></h4>
                <div class="table">
                    <div class="row">
                        <div class="attr_name"><?php echo S_PASSWORD ?></div>
                        <div class="attr_value"><input type="password" name="password" value="" /></div>
                    </div>
                    <div class="row">
                        <div class="attr_name"><?php echo S_RETYPE_PASSWORD ?></div>
                        <div class="attr_value"><input type="password" name="chpassword" value="" /></div>
                    </div>
                    <div class="footer">
                        <div class="attr_name"></div>
                        <div class="attr_name"><div class="save button" id="pass_change"><?php echo S_SAVE ?></div></div>
                    </div>
                </div>
                <?php if (!isLocalhost()) { ?>
                <hr>
                <h4><?php echo S_NEW_SW ?></h4>
                <form id="upgrade_form" method="POST" enctype="multipart/form-data" action="">
                    <input type="file" name="upload" id="file" accept=".tar.gz"/>
                    <input type="button" id="btn_upgrade" class="save button" value="<?php echo S_SAVE ?>" />
                </form>
                <?php } ?>
            </div>
            <div id="configuration">
                <h3><?php echo S_CONFIGURATION ?></h3>
                <hr />
                <h4><?php echo S_APP_NAME ?></h4>
                <h5><?php echo S_APP_DOWNLOAD ?></h5>
                <table>
                    <tr>
                        <td><span><?php echo S_TEXT_DEFINITION ?></span></td>
                        <td><div class="download button" name="def_txt"><?php echo S_DOWNLOAD ?></div></td>
                    </tr>
                    <tr>
                        <td><span><?php echo S_GUI_DEFINITION ?></span></td>
                        <td><div class="download button" name="def_zip"><?php echo S_DOWNLOAD ?></div></td>
                    </tr>
                </table>
                <h5><?php echo S_APP_UPLOAD ?></h5>
                <form method="POST" enctype="multipart/form-data" action="">
                    <table>
                        <tr>
                            <td><span><?php echo S_TEXT_DEFINITION ?></span></td>
                            <td><input type="file" name="upload_txt" id="file" accept=".txt"/></td>
                            <td><div class="delete button" name="delete_txt"><?php echo S_DELETE ?></div></td>
                        </tr>
                        <tr>
                            <td><span><?php echo S_GUI_DEFINITION ?></span></td>
                            <td><input type="file" name="upload_zip" id="file" accept=".zip"/></td>
                            <td><div class="delete button" name="delete_gui"><?php echo S_DELETE ?></div></td>
                        </tr>
                    </table>
                    <input type="submit" id="btn" class="save button" value="<?php echo S_SAVE ?>" />
                </form>
                <hr />
            </div>
        </div>
    </div>
    <div id="dialog-confirm" title="<?php echo S_RESTART ?>">
      <p><span class="ui-icon ui-icon-alert" style="float:left; margin:0 7px 20px 0;"></span><?php echo S_REBOOT_CONFIRM ?></p>
    </div>
    <div id="dialog-upgrade" title="<?php echo S_RESTART ?>">
      <p><span class="ui-icon ui-icon-alert" style="float:left; margin:0 7px 20px 0;"></span><?php echo S_UPGRADE_CONFIRM ?></p>
    </div>
    <div id="dialog-alert">
        <p><span class="ui-icon ui-icon-alert" style="float:left; margin:0 7px 20px 0;"></span><span id="text"></span></p>
    </div>
    <div id="dialog-upload" title="<?php echo S_UPLOAD ?>">
      <p><span class="ui-icon ui-icon-info" style="float:left; margin:0 7px 20px 0;"></span><?php echo S_UPLOAD_OK ?></p>
    </div>
    <div id="dialog-password" title="<?php echo S_UPLOAD ?>">
      <p><span class="ui-icon ui-icon-info" style="float:left; margin:0 7px 20px 0;"></span><?php echo S_PASSWORD_CHANGED ?></p>
    </div>
    <div id="dialog-restart" title="<?php echo S_RESTART ?>">
      <p><span class="ui-icon ui-icon-info" style="float:left; margin:0 7px 20px 0;"></span><?php echo S_RESTART_REQUIRED ?></p>
    </div>
    </body>
</html>
    <?php }?>
