/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

// Inicializace stránky nastavení
function initSettings() {
    var dhcp = $('#settings .toggle');
    dhcp.toggles({
        checkbox: $('#settings input[name="dhcp"]'),
        text: {
            on: lang['S_ON'],
            off:lang['S_OFF']
        }
    });
    $('#settings .save').click(function () {
        //get all inputs
        $('#settings_error').hide();
        var ilist = $('#settings select,input');
        $.blockUI(block_settings);
        $.ajax({
            url: 'sources/settings.php',
            method: 'POST',
            data: ilist.serialize(),
            dataType: 'json',
            error: function(jqXHR, textStatus, errorThrown) {
                if (jqXHR.status == 401)
                {
                    window.location = "/";
                    return;
                }
                $('#settings').effect("highlight", { color: 'lightcoral'}, 2000);
            },
            success: function(data) {
                if (!!data.error)
                {
                    $('#settings_error_message').text(data.error);
                    $('#settings_error').show();
                }
                else 
                {
                    $('#settings').effect("highlight", { color: 'lightgreen'}, 2000);
                    $( "#dialog-upload" ).dialog("open");
                }
            },
            complete: function() {
                $.unblockUI();
            }
        });
    });
    dhcp.on('toggle', function(e, active) {
        $('#settings input[name!="dhcp"]').prop("disabled", active);
        $('#settings input[name*="screen"]').prop("disabled", false);
    });
    $('#settings_error').hide();
    $('#run_screen_calibration').click(function () {
        $('body').addClass("running_external_app");
        $.ajax({
            url: 'sources/administration.php',
            method: 'POST',
            data: "action=calibrate",
            error: function(jqXHR, textStatus, errorThrown) {
                if (jqXHR.status == 401)
                {
                    window.location = "/";
                    return;
                }
            },
            complete: function() {
                $('body').removeClass("running_external_app");
                $( "#dialog-restart" ).dialog("open");
            }
        });
    });
    var settings = $.extend($('#settings'), {
        show: function() {
            $('#settings').show();
            $('#settings_error').hide();
            $.blockUI(block_settings);
            $.ajax({
                url: 'sources/settings.php',
                method: 'GET',
                dataType: 'json',
                error: function(jqXHR, textStatus, errorThrown) {
                    if (jqXHR.status == 401)
                    {
                        window.location = "/";
                        return;
                    }
                    $('#settings').effect("highlight", { color: 'lightcoral'}, 2000);
                },
                success: function(data) {
                    $('#settings input').each(function(){
                        if ($(this).attr("name") != "dhcp") {
                            $(this).val(data[this.name]);
                        }
                        else {
                            var chb = dhcp.data('toggles');
                            chb.toggle(!!data[this.name], true);
                        }
                    })
                },
                complete: function() {
                    $.unblockUI();
                }
            });
        },
        hide: function(productId) {
            $('#settings').hide();
        }
    });
    return settings;
}