<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
    function countSetbits($int){
        $int = $int & 0xFFFFFFFF;
        $int = ( $int & 0x55555555 ) + ( ( $int >> 1 ) & 0x55555555 );
        $int = ( $int & 0x33333333 ) + ( ( $int >> 2 ) & 0x33333333 );
        $int = ( $int & 0x0F0F0F0F ) + ( ( $int >> 4 ) & 0x0F0F0F0F );
        $int = ( $int & 0x00FF00FF ) + ( ( $int >> 8 ) & 0x00FF00FF );
        $int = ( $int & 0x0000FFFF ) + ( ( $int >>16 ) & 0x0000FFFF );
        $int = $int & 0x0000003F;
        return $int;
    }

    if (!defined('PHP_VERSION_ID')) {
        $version = explode('.', PHP_VERSION);

        define('PHP_VERSION_ID', ($version[0] * 10000 + $version[1] * 100 + $version[2]));
    }

    require_once('config.php');   // Configuration

    if (defined('S_E_OK')) {
        $errorTexts = array (
            E_OK => S_E_OK,
            E_FILE_OPEN => S_E_FILE_OPEN,
            E_FILE_WRITE => S_E_FILE_WRITE,
            E_VALIDATION => S_E_VALIDATION
        );
    }
    else {
        $errorTexts = array (
            E_OK => "OK",
            E_FILE_OPEN => "FILE_OPEN",
            E_FILE_WRITE => "FILE_WRITE",
            E_VALIDATION => "VALIDATION"
        );
    }

    function writeLines($file, $lines)
    {
        foreach($lines as $line)
        {
            if (!fwrite($file, $line."\n")) {
                return FALSE;
            }
        }
        return TRUE;
    }

    function writeDNS($dns)
    {
        $cfile = fopen("/etc/resolv.conf", "w");
        if (!$cfile) return E_FILE_OPEN;
        if (!fwrite($cfile, "nameserver ".$dns."\n")) {
            return E_FILE_WRITE;
        }
        exec("sync");    // Applicate settings
        return E_OK;
    }

    function setDefaultGW($gw)
    {
        exec("ip route add default via ".$gw);
        return E_OK;
    }

    function checkIPv4($ip) {
        // check non empty string value
        if (!$ip) { return FALSE; }
        if (!is_string($ip)) { return FALSE; }
        if (strlen($ip) == 0) { return FALSE; }
        // check numbers
        $nums = explode('.', $ip);
        if (count($nums) != 4) { return FALSE; }
        foreach ($nums as $num)
        {
            if (intval($num) < 0 || intval($num) > 255) { return FALSE; }
        }
        if (implode(".", array(intval($nums[0]), intval($nums[1]), intval($nums[2]), intval($nums[3]))) != $ip) { return FALSE; }
        return TRUE;
    }

    function setNetworkParametres($static, $ip, $mask, $gw, $dns) {
	$inifile=readIniFile("/etc/systemd/network/25-bridge.network");
        // static
        if ($static) {
            $inifile["Network"]["DHCP"]="no";
            if (!(checkIPv4($ip) || checkIPv4($mask))) {
                return E_VALIDATION;
            } else {
                $inifile["Network"]["Address"]=$ip."/".countSetbits(ip2long($mask));
            }
            if (checkIPv4($gw)) {
                $inifile["Network"]["Gateway"]=$gw;
            } else {
                $inifile["Network"]["Gateway"]="".long2ip((ip2long($ip) & ip2long("255.255.255.0"))+1);
            }
            if (checkIPv4($dns)) {
                $inifile["Network"]["DNS"]=$dns;
            }
        } else {    // DHCP
            $inifile["Network"]["DHCP"]="yes";
        }
        write_ini($inifile, "/etc/systemd/network/25-bridge.network");
	exec("networkctl reload && networkctl down && networkctl up");
        return E_OK;
    }

    function restartDevice() {
        if (file_exists(UPLOAD_DIR."/upgrade.lock")) {
            return;
        }
        $cmd="sudo /sbin/reboot";
        exec($cmd);
    }

    function uploadFile($file) {
        $error = E_OK;
        if($file) {
            if (!is_dir(UPLOAD_DIR))
            {
                mkdir(UPLOAD_DIR, 0777, true);
            }
            $uploaddest = UPLOAD_DIR."/".basename($file['name']);
            if(!move_uploaded_file($file['tmp_name'], $uploaddest)) {
                $error = E_FILE_WRITE;
            }
        }
        return $error;
    }

    function write_ini($data, $file = APP_HOME_DIR."/visual.ini") {
        $f = fopen($file, "w");
        if ($f) {
            // Write sections
            foreach ($data as $key => $value) {
                fwrite($f, "[".$key."]\n");
                foreach ($data[$key] as $k => $v) {
                    fwrite($f, $k."=".$v."\n");
                }
            }
            exec("sync");    // Applicate settings
        }
    }

    function getAppVersion() {
        $cmd = "QT_QPA_PLATFORM=minimal ".APP_WORK_DIR."/".APP_EXEC_NAME." --version";
        $version = exec($cmd);
        echo $version;
    }

    function getOSVersion() {
        exec("cd ".APP_WORK_DIR);
        $cmd = "QT_QPA_PLATFORM=minimal ".APP_WORK_DIR."/".APP_EXEC_NAME." -o";
        $version = exec($cmd);
        echo $version;
    }

    function getFtpVersion() {
        $version = exec("/usr/bin/sftpd -version");
        if (!$version)
        {
            $version = exec("/usr/sbin/sftpd -version");
        }
        echo $version;
    }

    function getVersion() {
	if (file_exists("version.txt")) {
            $version = exec("cat version.txt");
        }
        echo $version;
    }

    function isLocalhost() {
        return ($_SERVER["REMOTE_ADDR"] == "127.0.0.1" || $_SERVER["REMOTE_ADDR"] == "::1");
    }

    function calibrateScreen() {
        $script_command = "rm -rf /etc/pointercal && sync";

	exec($script_command);
    }

    function readIniFile($file = APP_HOME_DIR."/visual.ini")
    {
        $ini = array();
        if (file_exists($file)) {
            $ini = parse_ini_file($file, true);
        }
        return $ini;
    }

    function applyGuiDefinition() {
        $script_command = "./../shell/update_gui.sh";

	exec($script_command);
    }

    function get_client_ip() {
        $ipaddress = '';
        if (getenv('HTTP_CLIENT_IP'))
            $ipaddress = getenv('HTTP_CLIENT_IP');
        else if(getenv('HTTP_X_FORWARDED_FOR'))
            $ipaddress = getenv('HTTP_X_FORWARDED_FOR');
        else if(getenv('HTTP_X_FORWARDED'))
            $ipaddress = getenv('HTTP_X_FORWARDED');
        else if(getenv('HTTP_FORWARDED_FOR'))
            $ipaddress = getenv('HTTP_FORWARDED_FOR');
        else if(getenv('HTTP_FORWARDED'))
           $ipaddress = getenv('HTTP_FORWARDED');
        else if(getenv('REMOTE_ADDR'))
            $ipaddress = getenv('REMOTE_ADDR');
        else
            $ipaddress = 'UNKNOWN';
        return $ipaddress;
    }

    function set_storage($key, $value)
    {
        $file = WEB_DIR."/access.ini";
        $ini = array();
        if (file_exists($file)) {
            $ini = parse_ini_file($file, true);
        }

        clearConnections($ini);

        $ini[$key] = array($key => $value);
        $f = fopen($file, "w");
        foreach ($ini as $key => $value) {
            fwrite($f, "[".$key."]\n");
            foreach ($ini[$key] as $k => $v) {
                fwrite($f, $k."=".$v."\n");
            }
        }
        exec("sync");
    }

    function get_storage($key)
    {
        $file = WEB_DIR."/access.ini";
        $ini = array();
        if (file_exists($file)) {
            $ini = parse_ini_file($file, true);
        }
        if (!isset($ini[$key][$key]))
        {
            return FALSE;
        }
        else
        {
            return $ini[$key][$key];
        }
    }

    function clearConnections($arr)
    {
        $indx = "";
        $lastTime = 0;
        if (count($arr) > 5)
        {
            foreach ($arr as $k => $v) {
                if (!isset($lastTime) || $lastTime == 0) {
                    $indx = $k;
                    $lastTime = $v[$k];
                }
                if (isset($lastTime) && $lastTime > $v[$k])
                {
                    $indx = $k;
                    $lastTime = $v[$k];
                }
            }
        }
        if ($indx != "")
        {
            unset($arr[$indx]);
            return;
        }
    }
